/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.buff.Buff
 *  fire.pb.buff.continual.ConstantlyBuff
 *  xbean.Buff
 */
package fire.pb.skill;

import fire.pb.buff.Buff;
import fire.pb.buff.continual.ConstantlyBuff;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Result {
    private boolean success;
    private Map<Integer, Float> changedAttrs;
    private Map<Integer, Buff> addedBuffMap;
    private List<Integer> deletedBuffs;

    public Result(boolean success) {
        this.success = success;
        if (success) {
            this.changedAttrs = new HashMap<Integer, Float>();
            this.addedBuffMap = new HashMap<Integer, Buff>();
            this.deletedBuffs = new ArrayList<Integer>();
        }
    }

    public void clear() {
        this.changedAttrs.clear();
        this.addedBuffMap.clear();
        this.deletedBuffs.clear();
    }

    public void updateResult(Result result) {
        if (result.isSuccess()) {
            if (result.getChangedAttrs().size() != 0) {
                this.changedAttrs.putAll(result.getChangedAttrs());
            }
            for (Map.Entry<Integer, Buff> buff : result.getAddedBuffMap().entrySet()) {
                this.addAddedBuff(buff.getKey(), buff.getValue());
            }
            for (Integer buffId : result.getDeletedBuffs()) {
                this.addDeletedBuff(buffId);
            }
        }
    }

    public void updateChangedAttrs(Map<Integer, Float> newChangedAttrs) {
        this.changedAttrs.putAll(newChangedAttrs);
    }

    public boolean isSuccess() {
        return this.success;
    }

    public void setSuccess(boolean success) {
        this.success = success;
    }

    public Map<Integer, Float> getChangedAttrs() {
        return this.changedAttrs;
    }

    public void setChangedAttrs(Map<Integer, Float> changedAttrs) {
        this.changedAttrs = changedAttrs;
    }

    public Map<Integer, Buff> getAddedBuffMap() {
        return this.addedBuffMap;
    }

    public List<Integer> getDeletedBuffs() {
        return this.deletedBuffs;
    }

    public void addAddedBuff(ConstantlyBuff buff) {
        this.addAddedBuff(buff.getBuffBean());
    }

    public void addAddedBuff(xbean.Buff xbuff) {
        if (this.deletedBuffs.contains(xbuff.getIndex())) {
            this.deletedBuffs.remove(xbuff.getIndex());
            this.addedBuffMap.put(xbuff.getIndex(), this.getPrtlBuffFromXBuff(xbuff));
            return;
        }
        this.addedBuffMap.put(xbuff.getIndex(), this.getPrtlBuffFromXBuff(xbuff));
    }

    private void addAddedBuff(int buffId, Buff buff) {
        if (this.deletedBuffs.contains(buffId)) {
            this.deletedBuffs.remove((Object)buffId);
            this.addedBuffMap.put(buffId, buff);
            return;
        }
        this.addedBuffMap.put(buffId, buff);
    }

    public void addDeletedBuff(int buffId) {
        if (this.addedBuffMap.containsKey(buffId)) {
            this.addedBuffMap.remove(buffId);
            return;
        }
        if (this.deletedBuffs.contains(buffId)) {
            return;
        }
        this.deletedBuffs.add(buffId);
    }

    public void addDeletedBuff(ConstantlyBuff buff) {
        if (this.addedBuffMap.containsKey(buff.getId())) {
            this.addedBuffMap.remove(buff.getId());
            return;
        }
        if (this.deletedBuffs.contains(buff.getId())) {
            return;
        }
        this.deletedBuffs.add(buff.getId());
    }

    private Buff getPrtlBuffFromXBuff(xbean.Buff buff) {
        Buff ptrlbuff = new Buff();
        ptrlbuff.count = buff.getRound();
        if (buff.getRemaintime() <= 0L) {
            ptrlbuff.time = 0L;
        } else {
            ptrlbuff.time = (buff.getRemaintime() - (System.currentTimeMillis() - buff.getImpacttime())) / 1000L;
            if (ptrlbuff.time < 0L) {
                ptrlbuff.time = 0L;
            }
        }
        return ptrlbuff;
    }
}

